text = "hello world";

-- enregistre poulets leurre
  
 
objets = {} -- table to hold all our physical objects
pouletNormagImg = 0;
poulets = {} -- poulets sur lesquels faut pas cliquer
edges = {}

--screenShape =

thePoulet = {}
--attrapeMoi
--thePoulet = le poulet a attraper
--nb poulets initial
nbObjets = 5;

-- 0 = ingame
-- 1 = on gagne
state = 0
cageOuverte = false;

function creerUnPouletAleatoirement(x,y)
	poulet = {}
	--world, x (pos.x of body), y (yPosition), mass, rotationalInertia
	
	
	poulet.b = love.physics.newBody(world, x,y , 10,0)
	
	-- generer aleatoirement la force
	--poulet.b:applyForce(-20, 0)
	local vx = math.random(200) + 50;
	local vy = math.random(200) + 50;
	--local vy = 20;
	poulet.b:setLinearVelocity( vx,vy)
	--body, xOffset, yOffset, width, height, angle
	poulet.s = love.physics.newRectangleShape(poulet.b, --x-pouletSainImg:getWidth()/2,y-pouletSainImg:getHeight()/2,
												0,0,
												pouletSainImg:getWidth(),
												pouletSainImg:getHeight(),
											  0)
											  
	-- won't collide with mask 1
	poulet.s:setMask(1);
	poulet.s:setData("PouletSain")	
	return poulet
end			
			
			
function love.load()

	--initialize randomizer
	math.randomseed(os.time())

	-- for i=1,nbObjets do 
		-- objets[i] = 0;
	-- end
	
   --image = love.graphics.newImage("cake.jpg")
   local f = love.graphics.newFont(12)
   love.graphics.setFont(f)
   love.graphics.setColor(0,0,0,255)

   
   --thePoulet = love.graphics.newImage("poulet1.png");
   pouletSainImg = love.graphics.newImage("poulet1.png");
   pouletMaladeImg = love.graphics.newImage("poulet2.png");
   cageOuverteImg = love.graphics.newImage("grillage_ouvert.png");
   cageFermeeImg = love.graphics.newImage("grillage_ferme.png");
   
    -- setup physics
	--Store the new world in a variable such as "world"
	--love.graphics.getWidth()
    world = love.physics.newWorld(0,0,640,480)
    world:setGravity(0,0)
	world:setMeter(64) --the height of a meter in this world will be 64px
	
	
	
	--math.random(99999)
	for i=1,nbObjets do 
		local x,y =math.random(640), math.random(480);
		poulets[i] = creerUnPouletAleatoirement(x,y);
	end
	poulets[1].s:setData("PouletMalade");

										  
-- function add Called when two shapes first collide. 
-- function persist Called each frame, if collision lasts more than 1 frame. 
-- function remove Called when two shapes finish colliding. 
	--world:setCallbacks( onFirstCollision, nil, nil, nil )
end


--coll,getNormal()
function onFirstCollision(a, b, coll)
	print("Collision");
	
end
--function


function love.mousepressed(x, y, button)
	
	if button == 'l' then
   
		print("Clic souris en "..x.."/"..y.." bouton "..button);
		
	for i,poulet in pairs(poulets) do
		
		--print(" Test avec "..poulet.s:getData() );
		
		-- si j'ai clique dans la bbox d'un poulet alors je 
		if poulet.s:testPoint( x, y ) then
			
			print("Clique sur "..poulet.s:getData() );
			--local x,y = poulet.b:getPosition();
				
			-- si c le 1er poulet alors c'est le bon
			if i == 1 then
				print('Vous avez gagne')
				--redefinit
				font = love.graphics.newFont(14) -- the number denotes the font size
				function love.draw() 
					love.graphics.print("Vous avez gagne !" , 100, 100);
				end
				
				love.update = nil;
			else
				print("Cree 3 poulets sains " );
				-- sinon le jouer se trompe, On pop 3 nouveaux poulets
				table.insert( poulets, creerUnPouletAleatoirement(x,y) )
				table.insert( poulets, creerUnPouletAleatoirement(x,y) )
				table.insert( poulets, creerUnPouletAleatoirement(x,y) )
			end
			
			-- exit loop
			break;
		end
	end
    
   end
end

function love.mousereleased(x, y, button)

end


function love.keypressed(key, unicode)
   if key == ' ' then
      print("Ouverture de la Cage");
	  cageOuverte = true;
   end
end


function love.keyreleased(key, unicode)
   if key == ' ' then
      print("Fermeture de la Cage");
	  cageOuverte = false;
   end
end


function love.focus(f)
  if not f then
    print("LOST FOCUS")
  else
    print("GAINED FOCUS")
  end
end

function love.draw()
	time = love.timer.getTime( )

	love.graphics.setColor(255,255,255)
	--tostring(time)

	
    
    love.graphics.setBackgroundColor(255,255,255)
	--love.graphics.draw(pouletNormagImg);
	
	--x,y = body:getPosition
	for i in pairs(poulets) do
		love.graphics.draw(pouletSainImg, poulets[i].b:getX(),poulets[i].b:getY());
	end
	
	--affiche le poulet a capturer
	love.graphics.draw(pouletMaladeImg, poulets[1].b:getX(),poulets[1].b:getY());
	
	-- affiche la cage
	if cageOuverte then
		love.graphics.draw(cageOuverteImg,0,0)
	else
		love.graphics.draw(cageFermeeImg,0,0)
	end
	
	love.graphics.setColor(0,0,0)
	love.graphics.print( "Score = Temps ecoule: " ..tostring(time), 5, 5 )
end



-- dt en secondes
function love.update(dt)

	world:update(dt)
	
	-- check if within screen
	for i,poulet in pairs(poulets) do	
		--local x,y = poulet.b:
		X1, Y1, X2, Y2, X3, Y3, X4, Y4 = poulet.s:getBoundingBox();
		local vx,vy = poulet.b:getLinearVelocity( );
		
		if X3 > love.graphics.getWidth() or X1 < 0 then
			poulet.b:setLinearVelocity( -vx, vy);
			
		elseif Y3 > love.graphics.getHeight() or Y1 < 0 then
			poulet.b:setLinearVelocity( vx, -vy);
		end
	end
	
end

function love.quit()
  print("Thanks for playing! Come back soon!")
end